import sys
import asyncio
import logging
import websockets
from PyQt5 import QtCore, QtGui, QtWidgets
from qasync import QEventLoop

# Setup logging
logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')

class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(800, 600)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.pushButton = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton.setGeometry(QtCore.QRect(160, 360, 191, 71))
        font = QtGui.QFont()
        font.setPointSize(12)
        self.pushButton.setFont(font)
        self.pushButton.setObjectName("pushButton")
        self.pushButton_2 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_2.setGeometry(QtCore.QRect(400, 360, 191, 71))
        font = QtGui.QFont()
        font.setPointSize(12)
        self.pushButton_2.setFont(font)
        self.pushButton_2.setObjectName("pushButton_2")
        self.label = QtWidgets.QLabel(self.centralwidget)
        self.label.setGeometry(QtCore.QRect(160, 450, 171, 31))
        font = QtGui.QFont()
        font.setPointSize(16)
        font.setBold(True)
        font.setUnderline(True)
        self.label.setFont(font)
        self.label.setObjectName("label")
        self.label_2 = QtWidgets.QLabel(self.centralwidget)
        self.label_2.setGeometry(QtCore.QRect(200, 480, 61, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        font.setBold(True)
        self.label_2.setFont(font)
        self.label_2.setObjectName("label_2")
        self.label_3 = QtWidgets.QLabel(self.centralwidget)
        self.label_3.setGeometry(QtCore.QRect(200, 500, 61, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        font.setBold(True)
        self.label_3.setFont(font)
        self.label_3.setObjectName("label_3")
        self.label_4 = QtWidgets.QLabel(self.centralwidget)
        self.label_4.setGeometry(QtCore.QRect(200, 520, 61, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        font.setBold(True)
        self.label_4.setFont(font)
        self.label_4.setObjectName("label_4")
        self.label_5 = QtWidgets.QLabel(self.centralwidget)
        self.label_5.setGeometry(QtCore.QRect(270, 480, 49, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        self.label_5.setFont(font)
        self.label_5.setObjectName("label_5")
        self.label_6 = QtWidgets.QLabel(self.centralwidget)
        self.label_6.setGeometry(QtCore.QRect(270, 500, 49, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        self.label_6.setFont(font)
        self.label_6.setObjectName("label_6")
        self.label_7 = QtWidgets.QLabel(self.centralwidget)
        self.label_7.setGeometry(QtCore.QRect(270, 520, 49, 16))
        font = QtGui.QFont()
        font.setPointSize(12)
        self.label_7.setFont(font)
        self.label_7.setObjectName("label_7")
        self.label_8 = QtWidgets.QLabel(self.centralwidget)
        self.label_8.setGeometry(QtCore.QRect(120, 30, 531, 311))
        self.label_8.setFrameShape(QtWidgets.QFrame.Box)
        self.label_8.setLineWidth(5)
        self.label_8.setText("")
        self.label_8.setPixmap(QtGui.QPixmap("./Render.png"))
        self.label_8.setScaledContents(True)
        self.label_8.setObjectName("label_8")
        self.label_9 = QtWidgets.QLabel(self.centralwidget)
        self.label_9.setGeometry(QtCore.QRect(240, 250, 49, 41))
        font = QtGui.QFont()
        font.setPointSize(24)
        self.label_9.setFont(font)
        self.label_9.setObjectName("label_9")
        self.label_10 = QtWidgets.QLabel(self.centralwidget)
        self.label_10.setGeometry(QtCore.QRect(320, 220, 49, 41))
        font = QtGui.QFont()
        font.setPointSize(24)
        self.label_10.setFont(font)
        self.label_10.setObjectName("label_10")
        self.label_11 = QtWidgets.QLabel(self.centralwidget)
        self.label_11.setGeometry(QtCore.QRect(400, 180, 49, 41))
        font = QtGui.QFont()
        font.setPointSize(24)
        self.label_11.setFont(font)
        self.label_11.setObjectName("label_11")
        MainWindow.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 800, 22))
        self.menubar.setObjectName("menubar")
        MainWindow.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

        # Connect the buttons to their handlers
        self.pushButton.clicked.connect(self.start_button_handler)
        self.pushButton_2.clicked.connect(self.reset_button_handler)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MainWindow"))
        self.pushButton.setText(_translate("MainWindow", "START"))
        self.pushButton_2.setText(_translate("MainWindow", "RESET"))
        self.label.setText(_translate("MainWindow", "Slope Timing"))
        self.label_2.setText(_translate("MainWindow", "Slope 1"))
        self.label_3.setText(_translate("MainWindow", "Slope 2"))
        self.label_4.setText(_translate("MainWindow", "Slope 3"))
        self.label_5.setText(_translate("MainWindow", "T1"))
        self.label_6.setText(_translate("MainWindow", "T2"))
        self.label_7.setText(_translate("MainWindow", "T3"))
        self.label_9.setText(_translate("MainWindow", "3"))
        self.label_10.setText(_translate("MainWindow", "2"))
        self.label_11.setText(_translate("MainWindow", "1"))

    def start_button_handler(self):
        logging.info("START button pressed")
        asyncio.ensure_future(self.run_websocket())

    def reset_button_handler(self):
        logging.info("RESET button pressed")
        asyncio.ensure_future(self.send_command("reset"))

    async def run_websocket(self):
        try:
            async with websockets.connect('ws://192.168.10.194:8080', ping_interval=None) as websocket:
                logging.info("Connected to WebSocket server.")
                await self.send_command(websocket, "start")
                await self.receive_updates(websocket)
        except Exception as e:
            logging.error(f"Error running websocket: {e}", exc_info=True)

    async def send_command(self, websocket, command):
        logging.debug(f"Sending command: {command}")
        try:
            await websocket.send(command)
            logging.debug("Command sent successfully.")
        except Exception as e:
            logging.error(f"Error sending command: {e}", exc_info=True)

    async def receive_updates(self, websocket):
        try:
            while True:
                response = await websocket.recv()
                logging.info(f"Received update: {response}")
                self.update_timing_display(response)
        except websockets.exceptions.ConnectionClosed as e:
            logging.error(f"WebSocket connection closed: {e}")
        except Exception as e:
            logging.error(f"Error receiving updates: {e}", exc_info=True)

    def update_timing_display(self, timing_info):
        try:
            parts = timing_info.replace("Sensor Timings: ", "").split(", ")
            timing_dict = {k: v for k, v in (part.split("=") for part in parts)}

            t1 = timing_dict.get("S1", "--")
            t2 = timing_dict.get("S2", "--")
            t3 = timing_dict.get("S3", "--")

            self.label_5.setText(t1)
            self.label_6.setText(t2)
            self.label_7.setText(t3)
            logging.info(f"Updated UI: S1={t1}, S2={t2}, S3={t3}")
        except Exception as e:
            logging.error(f"Error updating display: {e}", exc_info=True)

if __name__ == "__main__":
    app = QtWidgets.QApplication(sys.argv)
    loop = QEventLoop(app)
    asyncio.set_event_loop(loop)

    MainWindow = QtWidgets.QMainWindow()
    ui = Ui_MainWindow()
    ui.setupUi(MainWindow)
    MainWindow.show()

    with loop:
        loop.run_forever()
